import com.sixlegs.image.png.*;
import java.awt.color.*;
import java.awt.image.*;
import java.awt.*;
import java.io.IOException;

public class ColorSpaceExample {
  public static void main (String[] args) {
    try {
      // Read PNG image from file
      PngImage png = new PngImage(args[0]);
      Image srcImg = Toolkit.getDefaultToolkit().createImage(png);
      // Get ICC Profile if available
      byte[] iccp_data = ((String)png.getProperty("icc profile")).getBytes();
      if (iccp_data != null) {
	ColorSpace cs_icc = new ICC_ColorSpace(ICC_Profile.getInstance(iccp_data));
	// Create a color model compatible with our image data
	// Same as ColorModel.getRGBdefault() except for ColorSpace argument
	ColorModel cm_icc = new DirectColorModel(cs_icc, 
						 32, 
						 0x00FF0000, 
						 0x0000FF00, 
						 0x000000FF, 
						 0xFF000000, 
						 false, 
						 DataBuffer.TYPE_INT);
	WritableRaster raster = cm_icc.createCompatibleWritableRaster(w, h);
	raster.setDataElements(0, 0, w, h, data);
	BufferedImage srcImg = new BufferedImage(cm_icc, raster, true, null);
	// We will convert to the sRGB color space
	ColorSpace cs_sRGB = ColorSpace.getInstance(ColorSpace.CS_sRGB);
	ColorConvertOp theOp = new ColorConvertOp(cs_sRGB);
	BufferedImage dstImg = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);
	// Do the conversion
	theOp.filter(srcImg, dstImg);
	// BufferedImage extends Image, so this is ok:
	srcImg = dstImg;
      }
      // Do something with srcImg here
    } catch (IOException e) { }
  }
}
