import com.sixlegs.image.png.*;
import java.awt.image.*;
import java.awt.*;
import java.io.IOException;

public class GrayscaleExample {
  public static void main (String[] args) {
    try {
      // Read PNG image from file
      PngImage png = new PngImage(args[0]);
      // Get chromaticity property if available
      double[][] chrom = (double[][])png.getProperty("chromaticity xyz");
      // Use luminance info from chromaticity array, or default
      ImageFilter gray = (chrom == null ?
			  new GrayscaleFilter() : 
			  new GrayscaleFilter(chrom[1][1], 
					      chrom[2][1], 
					      chrom[3][1]));
      // Chain PngImage to be filtered through GrayscaleFilter
      FilteredImageSource gray_src = new FilteredImageSource(png, gray);
      Image img = Toolkit.getDefaultToolkit().createImage(gray_src);
      // Do something with image here
    } catch (IOException e) { }
  }
}
