import com.sixlegs.image.png.*;
import java.awt.image.*;
import java.awt.*;
import java.io.IOException;

public class ObserverExample implements ImageObserver {

  public static void main (String[] args) {
    try {
      // Update ImageObservers after each interlace pass
      PngImage.setProgressiveDisplay(true);
      // Read PNG image from file
      PngImage png = new PngImage(args[0]);
      Toolkit tk = Toolkit.getDefaultToolkit();
      Image img = tk.createImage(png);
      int w = png.getWidth();
      int h = png.getHeight();
      // Call prepareImage using an instance of this class
      // as the ImageObserver; triggers imageUpdate (below)
      tk.prepareImage(img, w, h, new ObserverExample());
    } catch (IOException e) { }
  }

  public boolean imageUpdate (Image img, 
			      int infoflags, 
			      int x, int y, int w, int h) {
    if ((infoflags & ALLBITS) != 0 || 
	(infoflags & FRAMEBITS) != 0) {
      // We have a frame, do something with image here
    }
    return true;
  }
}
