import com.sixlegs.image.png.*;
import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.net.*;

public final class PngApplet extends Applet {
  private Color imgbg;
  private Image img;
  private PngImage png;

  public PngApplet () { }

  public void init () {
    String loc = getParameter("URL");
    try {
      if (loc != null) {
	URL url = new URL(getCodeBase(), loc);
	png = new PngImage(url);
	String bgparam = getParameter("bgcolor");
	if (bgparam != null)
	  imgbg = new Color(Integer.valueOf(bgparam, 16).intValue());
	if (imgbg == null)
	  imgbg = png.getBackgroundColor();
	if (imgbg == null)
	  imgbg = Color.white;
      	RemoveAlphaFilter remover = new RemoveAlphaFilter(imgbg);
      	ImageProducer src = new FilteredImageSource(png, remover);
  	img = Toolkit.getDefaultToolkit().createImage(src);
      }
    } catch (Exception e) { System.err.println(e); }
  }

  public void update (Graphics g) {
    paint(g);
  }

  public void paint (Graphics g) {
    try {
      if (img != null)
	g.drawImage(img, 0, 0, png.getWidth(), png.getHeight(), imgbg, null);
    } catch (Exception e) { }
  }

}

